<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Bootstrap Flex</title>
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
    <!-- Main Stylesheet -->
    <link rel="stylesheet" href="main.css">

</head>
<body>
    
    <h1 class="text-center py-5 bg-dark text-light">Bootstrap Flex</h1>
    <hr>
    <h3 class="text-center my-3">Flex Row</h3>
    <div class="bg-dark d-flex mb-4">
        <div class="bg-primary p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-success p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Flex Row Reverse</h3>
    <div class="bg-dark d-flex flex-row-reverse mb-4">
        <div class="bg-primary p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-success p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Flex Column</h3>
    <div class="bg-dark d-flex flex-column mb-4">
        <div class="bg-primary p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-success p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Flex Column Reverse</h3>
    <div class="bg-dark d-flex flex-column-reverse mb-4">
        <div class="bg-primary p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-success p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Flex Column Reverse Using CSS</h3>
    <!-- The div has some margin  because container class has some margin styles by bootstrap -->
    <div class="container mb-4">
        <div class="bg-primary p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-success p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Span as Flex Column Reverse</h3>
    <div class="bg-dark d-flex flex-column mb-4">
        <div class="bg-primary p-2">Span Flex item 1</div>
        <div class="bg-danger p-2">Span Flex item 2</div>
        <div class="bg-success p-2">Span Flex item 3</div>
    </div>
    <hr>
    <!-- Justify Content -->
    <h2 class="text-center text-light bg-dark py-5">Justify Content</h2>
    <h3 class="text-center my-5">Justify Content Start</h3>
    <div class="bg-dark d-flex flex-row justify-content-strat mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <div class="bg-dark d-flex flex-row-reverse justify-content-strat mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-5">Justify Content End</h3>
    <div class="bg-dark d-flex flex-row justify-content-end mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    
    <h3 class="text-center my-5">Justify Content Center</h3>
    <div class="bg-dark d-flex flex-row justify-content-center mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-5">Justify Content Between</h3>
    <div class="bg-dark d-flex flex-row justify-content-between mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <!-- Justify content around, it will automatically calculate th remaining space and distribute it evenly around our flex items -->
    <h3 class="text-center my-5">Justify Content Around</h3>
    <div class="bg-dark d-flex flex-row justify-content-around mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <hr>

    <h2 class="text-center text-light bg-dark py-5">Align Items</h2>
    <!-- Allows us to manipulate our items for flex-row and flex-row-reverse vertically.
    &&
    Allow us to manipulate or layout our items horizontally flex-column and flex-column-reverse -->
    <h3 class="text-center my-3">Align Items Start</h3>
    <div class="bg-dark d-flex flex-row align-items-start mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse align-items-start mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Align Items End</h3>
    <div class="bg-dark d-flex flex-row align-items-end mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse align-items-end mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <div class="bg-dark d-flex flex-column align-items-end mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-column-reverse align-items-end mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Align Items Center</h3>
    <div class="bg-dark d-flex flex-row align-items-center mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse align-items-center mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <h3 class="text-center my-3">Align Items Vertically and Horizontally</h3>
    <div class="bg-dark d-flex flex-row justify-content-end align-items-center mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <div class="bg-dark d-flex flex-row justify-content-end align-items-end mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>

    <div class="bg-dark d-flex flex-row justify-content-between align-items-center mb-4" style="height: 20vh;">
        <div class="bg-warning p-2">Flex item 1</div>
        <div class="bg-danger p-2">Flex item 2</div>
        <div class="bg-info p-2">Flex item 3</div>
    </div>
    <hr>

    <!-- Mini activity -->
    <h3 class="text-center py-5">Mini-Activity With Flex Row</h3>
    <div class="d-flex align-items-center justify-content-center bg-dark" style="height: 50vh;">
        <div class="bg-info p-2" >Box 1</div>
        <div class="bg-success p-2" >Box 2</div>
        <div class="bg-danger p-2" >Box 3</div>
    </div>
    <hr>
    <div class="d-flex align-items-center justify-content-around bg-dark justify-content-end" style="height: 50vh;">
        <div class="bg-info p-2" >Box 1</div>
        <div class="bg-success p-2" >Box 2</div>
        <div class="bg-danger p-2" >Box 3</div>
    </div>
    <hr>
    <!-- Mini Activity -->
    <div class="bg-dark mb-4 d-flex flex-column align-items-start justify-content-end" style="height: 50vh;">
        <div class="bg-info p-2" >Box 1</div>
        <div class="bg-success p-2" >Box 2</div>
        <div class="bg-danger p-2" >Box 3</div>
    </div>

    <div class="bg-dark mb-4 d-flex flex-column align-items-end" style="height: 50vh;">
        <div class="bg-info p-2" >Box 1</div>
        <div class="bg-success p-2" >Box 2</div>
        <div class="bg-danger p-2" >Box 3</div>
    </div>

    <!-- Flex Wrap -->
    <h2 class="text-center by-5">Flex Wrap</h2>
    <div class="bg-dark d-flex flex-row flex-wrap mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
        <div class="bg-danger p-2">Flex Item 2</div>
        <div class="bg-success p-2">Flex Item 3</div>
        <div class="bg-warning p-2">Flex Item 4</div>
        <div class="bg-info p-2">Flex Item 5</div>
        <div class="bg-primary p-2">Flex Item 6</div>
        <div class="bg-success p-2">Flex Item 7</div>
        <div class="bg-danger p-2">Flex Item 8</div>
        <div class="bg-warning p-2">Flex Item 9</div>
    </div>

    <!-- Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>

</body>
</html>